﻿addEventHandler("onResourceStart", resourceRoot,
function()
	database = dbConnect( "sqlite", "database.db" )
	if auto_load == true then
		loadDataBase()
	end
end)

function loadDataBase()
	local qh = dbQuery(database, "SELECT * FROM vehicles")
	if qh then
		local result, num_affected_rows, errmsg = dbPoll ( qh, -1 )
		if num_affected_rows > 0 then
			for result, row in pairs ( result ) do
				createNewVehicle(row)
			end
		end
	end
	local qh = dbQuery(database, "SELECT * FROM tents")
	if qh then
		local result, num_affected_rows, errmsg = dbPoll ( qh, -1 )
		if num_affected_rows > 0 then
			for result, row in pairs ( result ) do
				createNewTent(row,"tent")
			end
		end
	end
end

function saveDataBased()
	outputChatBox(" ",getRootElement(),255,255,255,true)
	outputChatBox("#FF0000BACKUP:#FFFFFF Идет сохранение данных сервера...",getRootElement(),255,255,255,true)
	destroyDataBase("tents")
	destroyDataBase("vehicles")
	for i,tent in ipairs(getElementsByType("colshape")) do 
		if getElementData(tent,"tent") and getElementData(tent,"parent") and tent then
			local x,y,z = getElementPosition(tent)
			local col = getElementData(tent,"parent")
			local rotx,roty,rot = getElementRotation(getElementData(tent,"parent"))
			if rot then
				local dataT = {}
				local noDeleteTent = false
				for i,v in ipairs(serverData["items"]) do
					local data = getElementData(tent,v[1]) or 0
					if data > 0 then 
						noDeleteTent = true
					end
					table.insert(dataT,{v[1],data})	
				end
				if noDeleteTent == true then
					local result = dbQuery( database, "INSERT INTO  `tents` VALUES ('"..x.."', '"..y.."', '"..z.."', '"..rot.."','"..toJSON(dataT).."');")
					dbFree (result)
				else
					destroyElement(tent)
					destroyElement(col)
				end
			end	
		end
	end
	for index,element in ipairs(getElementsByType("vehicle")) do 
		if not getElementData(element,"vehicleVSC") then
			local x,y,z = getElementPosition(element)
			local col = getElementData(element,"parent")
			local rotx,roty,rot = getElementRotation(element)
			local model = getElementModel(element)
			local health = getElementHealth(element)
			local dataT = {}
			for i,v in ipairs(serverData["items"]) do
				if col ~= false then
					local data = getElementData(col,v[1]) or 0
					table.insert(dataT,{v[1],data})
				end	
			end
			for i,v in ipairs(serverData["vehicle"]) do
				if col ~= false then
					local data = getElementData(col,v[1]) or 0
					table.insert(dataT,{v[1],data})
				end	
			end
			local result = dbQuery( database, "INSERT INTO  `vehicles` VALUES ('"..model.."','"..x.."', '"..y.."', '"..z.."', '"..rot.."','"..health.."', '"..toJSON(dataT).."');")
			dbFree (result)
		end	
	end	
	outputChatBox("#FF0000BACKUP:#FFFFFF Сохранение данных успешно завершено..",getRootElement(),255,255,255,true)
end
setTimer(saveDataBased,backTime,0)

function autoStopSave()
	if auto_save == true then
		saveDataBased()
	end
end	
addEventHandler("onResourceStop", getResourceRootElement(getThisResource()),autoStopSave)

addCommandHandler("save",function(player)
	if isObjectInACLGroup("user."..getAccountName(getPlayerAccount(player)),aclGetGroup(adm_group)) then 
		saveDataBased()
	end	
end)

addCommandHandler("load",function(player)
	if isObjectInACLGroup("user."..getAccountName(getPlayerAccount(player)),aclGetGroup(adm_group)) then 
		if auto_load == true then 
			outputChatBox("Включена автоматическая загрузка данных, загружать в ручную нельзя.",player,255,0,0,true)
			outputChatBox("Используйте собственную секретную команду для управления автозагрузкой.",player,255,0,0,true)
			return true
		end	
		loadDataBase()
		outputChatBox("#00cc00Данные с базы загружены.",player,255,255,255,true)
	end	
end)

addCommandHandler("autoloadoff",function(player)
	if isObjectInACLGroup("user."..getAccountName(getPlayerAccount(player)),aclGetGroup(adm_group)) then 
		if auto_load == true then 
			auto_load = false
			outputChatBox("Автозагрузка временно отключена!",player)
		else
			auto_load = true
			outputChatBox("Автозагрузка временно включена!",player)
		end
	end	
end)

function destroyDataBase(base)
	if base == "vehicles" then
		local qh = dbQuery(database, "DELETE FROM vehicles")
		local result = dbPoll( qh, -1 )
	elseif base == "tents" then
		local qh = dbQuery(database, "DELETE FROM tents")
		local result = dbPoll( qh, -1 )
	end
end

function createNewVehicle(row)
	local model = tonumber(row['model'])
	local data = fromJSON(row['data'])
	local x = tonumber(row['x'])
	local y = tonumber(row['y'])
	local z = tonumber(row['z'])
	local r = tonumber(row['r'])
	local health = tonumber(row['health'])
	veh = createVehicle(model,x,y,z,0,0,r)
	vehCol = createColSphere(x,y,z,3)
	attachElements(vehCol,veh,0,0,1.5)
	setElementData(vehCol,"parent",veh)
	setElementData(veh,"parent",vehCol)
	setElementData(vehCol,"vehicle",true)
	
	setElementData(vehCol,"Tire_inVehicledam",0)
	setElementData(vehCol,"Engine_inVehicledam",0)
	setElementData(vehCol,"Parts_inVehicledam",0)
	setElementData(vehCol,"Spareparts_inVehicle",0)
	
	setElementData(vehCol,"ID",row)
	setElementHealth(veh,health)
	for i,v in pairs(data) do
		setElementData(vehCol,v[1],v[2])
	end
end

function createNewTent(row,class) -- author: XaskeL (vk.com/xaskel) all mod
	local data = fromJSON(row['data'])
	local x = tonumber(row['x'])
	local y = tonumber(row['y'])
	local z = tonumber(row['z'])
	local r = tonumber(row['r'])
	if class == "tent" then
		tent = createObject(3243,x,y,z,0,0,r)
		setObjectScale(tent,1.3)
		tentCol = createColSphere(x,y,z,4)
		attachElements ( tentCol, tent, 0, 0, 0 )
		setElementData(tentCol,"parent",tent)
		setElementData(tent,"parent",tentCol)
		setElementData(tentCol,"tent",true)
		setElementData(tentCol,"vehicle",true)
		setElementData(tentCol,"hidetent",true)
		--setElementData(tentCol,"MAX_Slots",100)
		for i,v in pairs(data) do
			setElementData(tentCol,v[1],v[2])
		end
		if getElementData(tentCol,"MAX_Slots") == false or nil then
			setElementData(tentCol,"MAX_Slots",100)
		end
		if getElementData(tentCol,"MAX_Slots") == 100 then
			setElementModel(tent,3243)
		elseif getElementData(tentCol,"MAX_Slots") == 300 then
			setElementModel(tent,14581)
		end	
	end
end

function destroyThisVehicle(ps, cmd) 
	if isObjectInACLGroup ("user."..getAccountName ( getPlayerAccount ( ps ) ), aclGetGroup ( adm_group ) ) then 
		local theVehicle = getPedOccupiedVehicle(ps) 
		if (theVehicle) then 
			local col = getElementData(theVehicle, "parent") 
			destroyElement(col) 
			destroyElement(theVehicle) 
		else 
			outputChatBox("Вы должны находиться в транспорте.",ps,30,144,255,true)
		end 
	end 
end 
addCommandHandler("dtv", destroyThisVehicle)

function destroyVehiclePack(ps, cmd) 
	if isObjectInACLGroup ("user."..getAccountName ( getPlayerAccount (ps) ), aclGetGroup ( adm_group ) ) then 
		vehicles = getElementsByType("vehicle") 
		for i,v in ipairs(vehicles) do 
			local col = getElementData(v, "parent") 
			if isElement (col) then 
				destroyElement(col) 
			end
			destroyElement(v) 
		end
	end 
end 
addCommandHandler("dvp", destroyVehiclePack)